unit TypeUnit;

interface
uses Classes,Contnrs,Types;
type TMesto=class
              jmeno:string;
              x,y:integer;
              PathList:TStringList;
              fr_len,fr_cas,fr_ltr:integer; //hondoceni nalezene cesty
            end;
     TCesta=class
              cod,cdo:TMesto;
              nod,ndo:string;
              vzdalenost,rychlost:integer;
              cas_sec:integer;
              spotreba_ml:integer;
            end;

     TSpotreba=class
              rychlost:integer;
              spotreba:real;
            end;

procedure AddTown(name:string;px,py:integer);
procedure AddPath(zn,don:string;vzd,spd:integer);
procedure AddSpeed(spd:integer;l:real);

procedure ProcessPaths;
procedure ClearDocLists;
var TownList:TObjectList;
    TownRect:Trect;
    TownnameList:TStringList;
    PathList:TObjectList;
    SpeedList:TObjectList;
    SpeedSpeedList:TObjectList;
    FoundPathList:TObjectList;
implementation

uses StrUtils;

procedure AddTown(name:string;px,py:integer);
var town:TMesto;
begin
  town:=TMesto.Create;
  town.jmeno:=name;
  town.x:=px;
  town.y:=py;
  town.PathList:=TStringList.Create;
  TownList.Add(town);
  TownNameList.AddObject(name,town);
  if TownRect.Left>px then TownRect.Left:=px;
  if TownRect.Top>py then TownRect.Top:=py;
  if TownRect.Right<px then TownRect.Right:=px;
  if TownRect.Bottom<py then TownRect.Bottom:=py;
end;

procedure AddPath(zn,don:string;vzd,spd:integer);
var path:TCesta;
begin
  path:=TCesta.Create;
  path.nod:=zn;
  path.ndo:=don;
  path.vzdalenost:=vzd;
  Path.rychlost:=spd;
  path.cas_sec:=(vzd * 60 * 60) div spd; 
  PathList.Add(path);
end;


procedure AddSpeed(spd:integer;l:real);
var speed:TSpotreba;
begin
  speed:=TSpotreba.Create;
  speed.rychlost:=spd;
  speed.spotreba:=l;
  SpeedList.Add(speed);
//  SpeedSpeedList.Insert(spd,speed);
end;

procedure ProcessPaths;
var i:integer;
    path:TCesta;
begin
  for i:=0 to pred(PathList.Count) do begin
    path:=(Pathlist.items[i] as TCesta);
    path.cod:=TownNameList.Objects[TownNameList.IndexOf(path.nod)] as TMesto;
    path.cdo:=TownNameList.Objects[TownNameList.IndexOf(path.ndo)] as TMesto;

    path.cod.PathList.AddObject(path.ndo,path);
    path.cdo.PathList.AddObject(path.nod,path);    
    //path.spotreba_ml:=round((SpeedSpeedList.Items[path.rychlost] as TSpotreba).spotreba *1000);
  end;
end;
procedure ClearDocLists;
begin
TownList.Clear;
TownNameList.Clear;
PathList.Clear;
SpeedList.Clear;
SpeedSpeedList.Clear;
FoundPathList.Clear;
end;

begin
TownList:=TObjectList.Create(true);
TownNameList:=TStringList.Create;
PathList:=TObjectList.Create(true);
SpeedList:=TObjectList.Create(true);
SpeedSpeedList:=TObjectList.Create(false);
FoundPathList:=TObjectList.Create(false);
end.
