unit XMLUnit;
(*
  Jelikoz Delphi Personal Edition neobsahuji podporu XML, musi ji nkedo naprogramovat....
*)
interface
type float=real;
type
     PXMLNode=^TXMLNode;
     TXMLNode=class
                constructor Create(name:string);
{                function GetValue:string;
                function GetIntValue:integer;
                function GetFloatValue:float;
                function GetFirstChild:PXMLNode;
                procedure Free;}
              private
{                procedure AddChild(p:PXMLNode);
                _prvnidite:PXMLNode;
                _next:PXMLNode;
                _name:string;  }
              end;
     TXMLNodeValue=class(TXMLNode)
//                constructor Create(val:string);
{                function GetAsString:string;
                function GetAsInteger:integer;
                function GetAsFloat:float;}
                   private
                     _val:string;
                   end;
     TXMLDoc=class
//               s:string;
               constructor Create(filename:string);
              // procedure Free;
             private
               _root:PXMLNode;
             end;

implementation

uses SysUtils;

const XMLWhiteSpace=[#0..#32];

const buf_siz=8192;
var filebuf:packed array[1..buf_siz] of char;
    buf_pos:integer=-10;
    buf_max:integer;

function buf_GetChar(var f:File):char;
begin
  if buf_pos<=0 then begin
    blockread(f,filebuf,buf_siz,buf_max);
    buf_pos:=buf_max;
//  end else begin
  end;
  if (buf_max-buf_pos+1<=buf_max) then begin
    result:=filebuf[buf_max-buf_pos+1];
    dec(buf_pos);
  end else begin
    result:=#255;
  end;

end;

function buf_PeekChar(var f:File):char;
begin
  if buf_pos<=0 then begin
    blockread(f,filebuf,buf_siz,buf_max);
    buf_pos:=buf_max;
//  end else begin
  end;
  if (buf_max-buf_pos+1<=buf_max) then begin
    result:=filebuf[buf_max-buf_pos+1];
  end else begin
    result:=#255;
  end;
end;

function GetChar(var f:File):char;
begin
  result:=buf_GetChar(f);
end;

function GetWSChar(var f:file):char; //z vice "mezer" udela jednu mezeru
var c:char;
begin
  c:=buf_GetChar(f);
  if c in XMLWhiteSpace then
    while buf_PeekChar(f) in XMLWhiteSpace do c:=buf_GetChar(f);
  if c in XMLWhiteSpace then result:=#32 else result:=c;
end;

function buf_eof(var f:file):boolean;
begin
  result:=eof(f) and (buf_pos<=0);
end;


constructor TXMLDoc.Create(filename:string);
var f:file;
    enddoc:boolean;
    s:string;
    c:char;
begin
  filemode:=fmOpenRead;
  assign(f,filename);
  reset(f,1);
  s:='';
  enddoc:=false;
//  while not buf_eof(f) or enddoc do begin
    c:=GetWSChar(f);
    if c='<' then begin
      While c<>'>' do begin
        s:=s+c;
        c:=GetWSChar(f);
      end;
      s:=s+c;
    end;
//  end;
  if s<>'<?xml version="1.0" encoding="windows-1250"?>' then raise exception.Create('nepodporovany xml format'#13#10+s);
end;


constructor TXMLNode.Create(name:string);
begin


end;



end.
